﻿EnableExplicit

#LoadResEx_Dialog_Disabled = -1
Structure LoadResEx_Dialog_DialogInfo
  xEscBehaviour.i
  xButtonCtlID.i
  xCallBackProc.i
  EndStructure

Procedure.s RegReadString(uRGSection.s, uRGName.s)
  Define.s xResult
  Define.i xLong1

  If RegOpenKeyEx_($80000002, @uRGSection, 0, 1, @xLong1)
    xResult = RegQueryValueEx_String(xLong1, @uRGName)
    RegCloseKey_(xLong1)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s SimpleFile(xChar1.s)
  ProcedureReturn Mid(xChar1, InstrRevChar(xChar1, 92) + 1) ;"\"
  EndProcedure

Procedure.i LoadResEx_Dialog_InternalProc(HWndDialog.i, Msg.i, wParam.i, lParam.i)
  Define.i xResult
  Define.i FocusFromProc
  Define.i lblEndDialog
  Define *xType1.LoadResEx_Dialog_DialogInfo
  
  If Msg = $110
    If lParam
      *xType1 = lParam
      If *xType1\xCallBackProc
        xResult = CallWindowProc_(*xType1\xCallBackProc, HWndDialog, Msg, wParam, lParam)
        If xResult
          xResult = GetDlgItem_(HWndDialog, xResult)
          FocusFromProc = #True
          EndIf
        EndIf
      If Not FocusFromProc
        If *xType1\xButtonCtlID
          xResult = GetDlgItem_(HWndDialog, *xType1\xButtonCtlID)
          If xResult
            FocusFromProc = #True
            Else
            xResult = 1
            EndIf
          EndIf
        EndIf
      If FocusFromProc
        If xResult
          SetFocus_(xResult)
          xResult = 0
          Else
          xResult = 1
          EndIf
        EndIf
      SetWindowLong_(HWndDialog, -21, *xType1)
      EndIf
    Else
    *xType1 = GetWindowLong_(HWndDialog, -21)
    If *xType1
      Select Msg
        Case $10
          If Not *xType1\xEscBehaviour = #LoadResEx_Dialog_Disabled
            lblEndDialog = #True
            EndIf
        Case #WM_COMMAND
          If lParam
            If GetWindowLong_(lParam, -16) & $E
              If *xType1\xCallBackProc
                CallWindowProc_(*xType1\xCallBackProc, HWndDialog, Msg, wParam, lParam)
                EndIf
              ElseIf *xType1\xCallBackProc
              If CallWindowProc_(*xType1\xCallBackProc, HWndDialog, Msg, wParam, lParam) = 1
                *xType1\xEscBehaviour = wParam
                lblEndDialog = #True
                EndIf
              Else
              *xType1\xEscBehaviour = wParam
              lblEndDialog = #True
              EndIf
            ElseIf wParam = 2 And Not *xType1\xEscBehaviour = #LoadResEx_Dialog_Disabled
            lblEndDialog = #True
            EndIf
        EndSelect
      If lblEndDialog
        If *xType1\xCallBackProc
          CallWindowProc_(*xType1\xCallBackProc, HWndDialog, $12, wParam, lParam)
          EndIf
        EndDialog_(HWndDialog, *xType1\xEscBehaviour)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i LoadResEx_Dialog(hWndOwner.i, ResDialogOrID.i, DefaultButtonID.i = 0, CanEscapeControlID.i = #LoadResEx_Dialog_Disabled, *CallBackProc = 0)
  Define.i xResult
  Define.LoadResEx_Dialog_DialogInfo xType1
    
  xType1\xCallBackProc = *CallBackProc
  xType1\xEscBehaviour = CanEscapeControlID
  xType1\xButtonCtlID = DefaultButtonID
  xResult = DialogBoxParam_(hInstance, ResDialogOrID, hWndOwner, @LoadResEx_Dialog_InternalProc(), @xType1)
  ProcedureReturn xResult
  EndProcedure

Procedure.s SimpleDir(xChar1.s)
  Define.s xResult
  Define.i xLong1

  xLong1 = InstrRevChar(xChar1, 92) ; "\"
  If xLong1
    xResult = Left(xChar1, xLong1 - 1)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i RegisterServiceProcess(dwProcessId.i, dwType.i)
  Define.i xResult

  xResult = GetModuleHandle_(@"kernel32.dll")
  If xResult
    xResult = GetProcAddress(xResult, "RegisterServiceProcess")
    If xResult
      xResult = CallFunctionFast(xResult, dwProcessId, dwType)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure SetMenuShortcut(hMenu.i, MenuID.i, ShortCut.s)
  Define.i xLong1
  Define.s xChar1
  
  xChar1 = LoadResEx_Menu_GetCaption(hMenu, MenuID)
  xLong1 = FindString(xChar1, #TAB$)
  If xLong1 = 0
    If Len(ShortCut)
      xChar1 = xChar1 + #TAB$ + ShortCut
      EndIf
    ElseIf Len(ShortCut)
    xChar1 = Left(xChar1, xLong1) + ShortCut
    Else
    xChar1 = Left(xChar1, xLong1 - 1)
    EndIf
  LoadResEx_Menu_SetCaption(hMenu, MenuID, xChar1)
  EndProcedure

Procedure.s GetTimeFormatNow(xMode.i = 0)
  Define.s xResult
  Define.i xLong1
  Define.SYSTEMTIME xType1
  
  GetSystemTime_(xType1)
  xLong1 = GetTimeFormat_(1024, 0, @xType1, 0, *ptrTemp, #ptrTempSizeXAW)
  If xLong1 > 0
    xResult = PeekS(*ptrTemp, xLong1)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i LoadResData_CopyMOS(*resName, *ResType, *ptrSize)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  
  xLong1 = GetResDataPos_MultiOS(*resName, *ResType, @xLong2)
  If xLong1 And xLong2
    xResult = MemAllocNC(xLong2)
    If xResult
      MemCopyRTL(xResult, xLong1, xLong2)
      If *ptrSize
        PokeI(*ptrSize, xLong2)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i GetShiftCode()
  Define.i xResult

  If (GetAsyncKeyState_($10) & #AsyncKeyPressedMask)
    xResult = 1
    EndIf
  If (GetAsyncKeyState_($11) & #AsyncKeyPressedMask)
    xResult | 2
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i IsShiftPressed()
  Define.i xResult
  If (GetAsyncKeyState_($10) & #AsyncKeyPressedMask)
    xResult = #True
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i IsCtrlPressed()
  Define.i xResult
  If (GetAsyncKeyState_($11) & #AsyncKeyPressedMask)
    xResult = #True
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i IsAltPressed()
  Define.i xResult
  If (GetAsyncKeyState_($12) & #AsyncKeyPressedMask)
    xResult = #True
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure LoadResEx_Dialog_ManualTab(TopHWnd.i, CurHWnd.i)
  If IsShiftPressed()
    CurHWnd = GetNextDlgTabItem_(TopHWnd, CurHWnd, 1)
    Else
    CurHWnd = GetNextDlgTabItem_(TopHWnd, CurHWnd, 0)
    EndIf
  If CurHWnd
    SetFocus_(CurHWnd)
    EndIf
  EndProcedure

Procedure LoadResEx_Window_ManualTab(TopHWnd.i, CurHWnd.i)
  LoadResEx_Dialog_ManualTab(TopHWnd, CurHWnd)
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 169
; FirstLine = 166
; Folding = ---
; EnableUnicode
; EnableXP