﻿EnableExplicit

LibBuild_Include(GetOpenSavePatcher)

Structure GetOpenFilename_MultiResult
  hMem.i
  IsPT.i
  hPos.i
  EndStructure

Procedure.i GetOpenFileName_Multi_GetDialog(hWnd.i, Title.s, Filename.s, Patterns.s, PatternIndex.i)
  Define.i xResult
  Define *hmResult.GetOpenFilename_MultiResult
  Define.OPENFILENAME xType1
  
  *hmResult = MemAllocNC(SizeOf(GetOpenFilename_MultiResult))
  If *hmResult
    GetOpenSavePatcher_Patch(@xType1, hWnd, Filename, Patterns)
    xType1\nFilterIndex = PatternIndex
    xType1\Flags = #OFN_HIDEREADONLY | #OFN_EXPLORER | #OFN_ENABLESIZING | #OFN_FILEMUSTEXIST | #OFN_ALLOWMULTISELECT
    If GetOpenFileName_(@xType1)
      *hmResult\hMem = xType1\lpstrFile
      *hmResult\hPos = xType1\lpstrFile
      *hmResult\IsPT = 0
      xType1\lpstrFile = 0
      xResult = *hmResult
      EndIf
    GetOpenSavePatcher_Free(@xType1)
    If Not xResult
      MemFree(*hmResult)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i GetOpenFileName_Multi_HasFile(*hOFResult.GetOpenFilename_MultiResult)
  Define.i xResult

  If *hOFResult
    If *hOFResult\hMem
      CompilerIf #PB_Compiler_Unicode
        If PeekW(*hOFResult\hPos)
          xResult = #True
          EndIf
        CompilerElse
        If PeekB(*hOFResult\hPos)
          xResult = #True
          EndIf
        CompilerEndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s GetOpenFileName_Multi_GetFile(*hOFResult.GetOpenFilename_MultiResult, JustPathOnFirst.i = #False)
  Define.s xChar1

  If *hOFResult
    If *hOFResult\hMem
      Repeat
        CompilerIf #PB_Compiler_Unicode
          If Not PeekW(*hOFResult\hPos)
            Break
            EndIf
          CompilerElse
          If Not PeekB(*hOFResult\hPos)
            Break
            EndIf
          CompilerEndIf
        xChar1 = PeekS(*hOFResult\hPos)
        CompilerIf #PB_Compiler_Unicode
          *hOFResult\hPos + ((Len(xChar1) + 1) << 1)
          CompilerElse
          *hOFResult\hPos + (Len(xChar1) + 1)
          CompilerEndIf
        If *hOFResult\IsPT
          If Not JustPathOnFirst
            xChar1 = PeekS(*hOFResult\hMem) + "\" + xChar1
            EndIf
          Break
          Else
CompilerIf #PB_Compiler_Unicode
          If PeekW(*hOFResult\hPos)
CompilerElse
          If PeekB(*hOFResult\hPos)
CompilerEndIf
            *hOFResult\IsPT = #True
            JustPathOnFirst = #False
            If Right(xChar1, 1) = "\"
              If Len(xChar1) > 2
                CompilerIf #PB_Compiler_Unicode
                  PokeW(*hOFResult\hPos - 4, 0)
                  CompilerElse
                  PokeB(*hOFResult\hPos - 2, 0)
                  CompilerEndIf
                EndIf
              EndIf
            Else
            Break
            EndIf
          EndIf
        ForEver
      EndIf
    EndIf
  ProcedureReturn xChar1
  EndProcedure

Procedure GetOpenFileName_Multi_CloseResult(*hOFResult.GetOpenFilename_MultiResult)
  If *hOFResult
    If *hOFResult\hMem
      MemFree(*hOFResult\hMem)
      EndIf
    MemFree(*hOFResult)
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; Folding = --
; EnableUnicode
; EnableXP