EnableExplicit

Structure HyperlinkListItemStruct
  xText.i
  LenText.i
  LnkRect.RECT
  LnkURL.i
  LnkCaption.i
  LnkCapLen.i
  xHeight.i
  Padding.RECT
  hIcon.i
  IconIdent.i
  IconTOff.i
  IconSizeX.i
  IconSizeY.i
  IconDescardable.b
  EndStructure

#HyperlinkList_PaddingIcon = 4

Procedure.i HyperlinkList_WM_DRAWITEM(*lParam.DRAWITEMSTRUCT)
  Define.i xLong1
  Define.i xLong2
  Define *xType2.HyperlinkListItemStruct
  Define.RECT xType1
  Define.RECT xType3

  If *lParam
    If *lParam\hdc
      MemCopyRTL(@xType1, @*lParam\rcItem, SizeOf(RECT))
      xLong1 = GetBkColor_(*lParam\hdc)
      xLong2 = GetTextColor_(*lParam\hdc)
      SetBkColor_(*lParam\hdc, GetSysColor_(5)) ;5))
      FillRect_(*lParam\hdc, @xType1, 6) ;6)

      If Not *lParam\ItemID = -1
        If *lParam\itemData
          *xType2 = *lParam\itemData
          If *xType2\hIcon
            DrawIconEx_(*lParam\hdc, xType1\Left + *xType2\IconIdent, xType1\Top + *xType2\Padding\Top + *xType2\IconTOff, *xType2\hIcon, *xType2\IconSizeX, *xType2\IconSizeY, 0, 0, 3)
            EndIf
          
          MemCopyRTL(@xType3, @xType1, SizeOf(RECT))
          xType1\Left + *xType2\Padding\Left ; HyperlinkList_PaddingL
          xType1\Right - *xType2\Padding\Right
          xType1\Top + *xType2\Padding\Top
          xType1\Bottom - *xType2\Padding\right
          ;  endif
          If *xType2\xText
            DrawText_(*lParam\hdc, *xType2\xText, *xType2\LenText, @xType1, $110)
            EndIf
          
          If *xType2\LnkCapLen
            xType1\Right = xType1\Left + *xType2\LnkRect\Right
            xType1\Left + *xType2\LnkRect\Left
            xType1\Bottom = xType1\Top + *xType2\LnkRect\Bottom
            xType1\Top + *xType2\LnkRect\Top
            
            If (*lParam\itemState & $11)
              FillRect_(*lParam\hdc, @xType1, 14)
              SetBkColor_(*lParam\hdc, GetSysColor_(13))
              SetTextColor_(*lParam\hdc, GetSysColor_(14))
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
              Else
              SetTextColor_(*lParam\hdc, GetSysColor_(26)) ;13))
CompilerElse
  CompilerIf #PB_Compiler_Unicode
              ElseIf IsMinWindows2000
  CompilerElse
              ElseIf IsMinWindows98
  CompilerEndIf
              SetTextColor_(*lParam\hdc, GetSysColor_(26)) ;13))
              Else
              SetTextColor_(*lParam\hdc, GetSysColor_(13)) ;13))
CompilerEndIf
              EndIf
            DrawText_(*lParam\hdc, *xType2\LnkCaption, *xType2\LnkCapLen, @xType1, $110)
            Else
            If (*lParam\itemState & $11) And *xType2\xText
              DrawFocusRect_(*lParam\hdc, @xType3)
              EndIf
            EndIf
          EndIf
        EndIf
      SetBkColor_(*lParam\hdc, xLong1)
      SetTextColor_(*lParam\hdc, xLong2)
      EndIf
    EndIf
  ProcedureReturn 1
  EndProcedure

Procedure HyperlinkList_WM_ERASEBKGND(hWnd.i, wParam.i)
  Define.RECT xType1

  If wParam
    If GetClientRect_(hWnd, @xType1)
      FillRect_(wParam, @xType1, 6) ;6)
      EndIf
    EndIf
  EndProcedure

;boolean
Procedure.i HyperlinkList_HitTest(hWnd.i, lParam.i)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define.RECT xType1
  Define *xType2.HyperlinkListItemStruct
        
  xLong1 = SendMessage_(hWnd, $1A9, 0, lParam)
  If (xLong1 & $FFFF0000) = 0
    *xType2 = SendMessage_(hWnd, $199, xLong1, 0)
    If Not (*xType2 = 0 Or (*xType2 & $ffffffff) = $ffffffff)
      If *xType2\LnkURL
        If Not SendMessage_(hWnd, #LB_GETITEMRECT, xLong1, @xType1) = -1
          xLong1 = SignedLowerWord(lParam) - 1 ; x
          xLong2 = SignedHigherWord(lParam) + 1 ;y
          If xLong1 > xType1\Left + *xType2\LnkRect\Left + *xType2\Padding\Left
            If xLong1 <= xType1\Left + *xType2\LnkRect\Right + *xType2\Padding\Left
              If xLong2 > xType1\Top + *xType2\LnkRect\Top + *xType2\Padding\Top
                If xLong2 <= xType1\Top + *xType2\LnkRect\Bottom + *xType2\Padding\Top
                  xResult = #True
                  EndIf
                EndIf
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i HyperlinkList_ProcEv(hWnd.i, Msg.i, Msg2.i, lParam.i)
  Define.i hProc

  If HyperlinkList_HitTest(hWnd, lParam)
    hProc = GetWindowLong_(hWnd, -21)
    If hProc
      Msg = CallWindowProc_(hProc, hWnd, Msg, 0, lParam)
      CallWindowProc_(hProc, hWnd, Msg2, 0, lParam)
      ProcedureReturn Msg
      EndIf
    ProcedureReturn 0
    EndIf
  SetFocus_(hWnd)
  ProcedureReturn 0
  EndProcedure

Procedure.i HyperlinkList_Proc(hWnd.i, Msg.i, wParam.i, lParam.i)
  Define.i xLong1

  Select Msg
    ;Case $100, $101 ; WM_Key
    ;Case $104, $105 ; WM_SKey
    Case $102 ;WM_CHAR
      If wParam = 32
        SendMessage_(GetParent_(hWnd), $111, GetDlgCtrlID_(hWnd) | $20000, hWnd)
        EndIf
      ProcedureReturn 0
    Case $14
      HyperlinkList_WM_ERASEBKGND(hWnd, wParam)
      ProcedureReturn 0
    Case $200, $202
      ProcedureReturn 0
    Case $201
      ProcedureReturn HyperlinkList_ProcEv(hWnd, Msg, $202, lParam)
    Case $203
      ProcedureReturn HyperlinkList_ProcEv(hWnd, Msg, $200, lParam)
    EndSelect

  xLong1 = GetWindowLong_(hWnd, -21)
  If xLong1
    xLong1 = CallWindowProc_(xLong1, hWnd, Msg, wParam, lParam)
    EndIf
  ProcedureReturn xLong1
  EndProcedure

Procedure.i HyperlinkList_WM_MEASUREITEM(*lParam.MEASUREITEMSTRUCT)
  Define *xType2.HyperlinkListItemStruct

  If *lParam
    If *lParam\itemData
      *xType2 = *lParam\itemData
      *lParam\itemHeight = *xType2\xHeight
      EndIf
    EndIf
  ProcedureReturn 1
  EndProcedure

Procedure.i HyperlinkList_WM_DELETEITEM(*lParam.DELETEITEMSTRUCT)
  Define *xType2.HyperlinkListItemStruct

  If *lParam
    If *lParam\itemData
      *xType2 = *lParam\itemData
      If *xType2\xText
        MemFree(*xType2\xText)
        EndIf
      If *xType2\LnkCaption
        MemFree(*xType2\LnkCaption)
        EndIf
      If *xType2\LnkURL
        If Not *xType2\LnkURL = *xType2\LnkCaption
          MemFree(*xType2\LnkURL)
          EndIf
        EndIf
      If *xType2\IconDescardable And *xType2\hIcon
        DestroyIcon_(*xType2\hIcon)
        EndIf
      MemFree(*xType2)
      EndIf
    EndIf
  ProcedureReturn 1
  EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 193
; FirstLine = 187
; Folding = --
; EnableUnicode
; EnableXP