EnableExplicit

;LibBuild_IsIncluded
;CompilerIf Defined(LibBuild_IconFromDualEMF_Included, #PB_Constant) Or Defined(LibBuild_IconFromDualEMF_Included, #PB_Constant)

CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
  LibBuild_Include(BitmapStretchCopyEx)
  CompilerEndIf

Procedure IconFromEMF_ColorFix(hDC.i, *lpHTable, *lpEMFR.ENHMETARECORD, nObj.i, lpData.i)
  Define.i xEMRL_CBI.EMRCREATEBRUSHINDIRECT
  Define.i xEMRL_ECP.EMREXTCREATEPEN

  If *lpEMFR
    Select *lpEMFR\iType
      Case #EMR_CREATEBRUSHINDIRECT
        MemCopyRTL(@xEMRL_CBI, *lpEMFR, SizeOf(EMRCREATEBRUSHINDIRECT))
        xEMRL_CBI\lb\lbColor = lpData
        PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_CBI, nObj)
      Case #EMR_EXTCREATEPEN
        MemCopyRTL(@xEMRL_ECP, *lpEMFR, SizeOf(EMREXTCREATEPEN))
        xEMRL_ECP\elp\elpColor = lpData
        PlayEnhMetaFileRecord_(hDC, *lpHTable, @xEMRL_ECP, nObj)
      Default
        PlayEnhMetaFileRecord_(hDC, *lpHTable, *lpEMFR, nObj)
      EndSelect
    EndIf

  ProcedureReturn #True
  EndProcedure

Macro IconFromEMF_QualityShift(Value)
  (Value << 2)
  EndMacro

; Note that on Win7 classic taskswitcher (appears when switching FROM certain games) the simple dual-rgb icons dont work
; (note those work on win2000!)
; btw the alpha icons are more accurate regarding transparency, so it wasn't just time wasted for a workaround

CompilerIf Defined(LibBuild_IconFromDualEMF_Included, #PB_Constant) Or Defined(LibBuild_IconFromDualEMF_Included, #PB_Constant)
Procedure.i IconFromEMF(hMeta1.i, SizeX1.i = 0, SizeY1.i = 0, hMeta2.i = 0, PosX2.i = 0, PosY2.i = 0, SizeX2.i = 0, SizeY2.i = 0)
CompilerElse
Procedure.i IconFromEMF(hMeta1.i, SizeX1.i = 0, SizeY1.i = 0)
CompilerEndIf
  Define.i xResult
  Define.i hDC
  Define.i hBmpOld
  ;Define.i hEmf
  Define.i hBrush
  Define.RECT xType1
CompilerIf Defined(IconFromDualEMF, #PB_Constant)
  Define.RECT xType2
CompilerEndIf
  Define.ICONINFO xType3
  Define.i hBmpCol
  Define.i hBmpMsk
  
  Define.BITMAPV5HEADER bi
  Define *xBmpCol
  Define *xBmpMsk
  Define *xBmpMix
  Define.i xX
  Define.i xY
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xRB
  Define.i xG
  Define.i xA

  If hMeta1
    hDC = GetDC_(0)
    If hDC
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
      If IsMinWindowsXP
CompilerEndIf
        With bi
          \bV5Size = SizeOf(BITMAPV5HEADER);
          \bV5Width = SizeX1 << 1
          \bV5Height = SizeY1 << 1
          \bV5Planes = 1;
          \bV5BitCount = 32;
          \bV5Compression = #BI_bitfields;
          ; The following mask specification specifies a supported 32 BPP
          ; alpha format For Windows XP.
          \bV5RedMask   =  $00FF0000;
          \bV5GreenMask =  $0000FF00;
          \bV5BlueMask  =  $000000FF;
          \bV5AlphaMask =  $FF000000;
          EndWith

        hBmpCol = CreateDIBSection_(hDC, @bi, #DIB_RGB_COLORS, @*xBmpCol, 0, 0)
        hBmpMsk = CreateDIBSection_(hDC, @bi, #DIB_RGB_COLORS, @*xBmpMsk, 0, 0)
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
        Else
        hBmpCol = CreateCompatibleBitmap_(hDC, IconFromEMF_QualityShift(SizeX), IconFromEMF_QualityShift(SizeY))
        hBmpMsk = CreateCompatibleBitmap_(hDC, IconFromEMF_QualityShift(SizeX), IconFromEMF_QualityShift(SizeY))
        EndIf
CompilerEndIf

      ReleaseDC_(0, hDC)
      If hBmpCol
        If hBmpMsk
          hDC = CreateCompatibleDC_(0)
          If hDC
            hBmpOld = SelectObject_(hDC, hBmpCol)
            If hBmpOld
              CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                xType1\right = SizeX1 << 1
                xType1\bottom = SizeY1 << 1
                CompilerElse
                If IsMinWindowsXP
                  xType1\right = SizeX1 << 1
                  xType1\bottom = SizeY1 << 1
                  Else
                  xType1\right = IconFromEMF_QualityShift(SizeX1)
                  xType1\bottom = IconFromEMF_QualityShift(SizeY1)
                  EndIf
                CompilerEndIf

              hBrush = CreateSolidBrush_($808080)
              If hBrush
                FillRect_(hDC, xType1, hBrush)
                DeleteObject_(hBrush)
                EndIf
              If PlayEnhMetaFile_(hDC, hMeta1, @xType1)
CompilerIf Defined(IconFromDualEMF, #PB_Constant)
                If hMeta2
                  xType2\left = PosX2
                  xType2\top = PosY2
                  xType2\right = PosX2 + SizeX2
                  xType2\bottom = PosY2 + SizeY2
                  If PlayEnhMetaFile_(hDC, hMeta2, @xType2)
                    xResult = #True
                    EndIf
                  Else
                  xResult = #True
                  EndIf
                If xResult
                  xResult = #False
CompilerEndIf
                  If SelectObject_(hDC, hBmpMsk)
                    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                      hBrush = CreateSolidBrush_($000000)
                      CompilerElse
                      If IsMinWindowsXP
                        hBrush = CreateSolidBrush_($000000)
                        Else
                        hBrush = CreateSolidBrush_($ffffff)
                        EndIf
                      CompilerEndIf
                    If hBrush
                      FillRect_(hDC, xType1, hBrush)
                      DeleteObject_(hBrush)
                      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                        If EnumEnhMetaFile_(hDC, hMeta1, @IconFromEMF_ColorFix(), $ffffff, @xType1)
                          CompilerIf Defined(IconFromDualEMF, #PB_Constant)
                            If hMeta2
                              If EnumEnhMetaFile_(hDC, hMeta2, @IconFromEMF_ColorFix(), $ffffff, @xType2)
                                xResult = #True
                                EndIf
                              Else
                              xResult = #True
                              EndIf
                            CompilerElse
                            xResult = #True
                            CompilerEndIf
                          EndIf                      
                        CompilerElse
                        If IsMinWindowsXP
                          If EnumEnhMetaFile_(hDC, hMeta1, @IconFromEMF_ColorFix(), $ffffff, @xType1)
                            CompilerIf Defined(IconFromDualEMF, #PB_Constant)
                              If hMeta2
                                If EnumEnhMetaFile_(hDC, hMeta2, @IconFromEMF_ColorFix(), $ffffff, @xType2)
                                  xResult = #True
                                  EndIf
                                Else
                                xResult = #True
                                EndIf
                              CompilerElse
                              xResult = #True
                              CompilerEndIf
                            EndIf                      
                          ElseIf EnumEnhMetaFile_(hDC, hMeta1, @IconFromEMF_ColorFix(), 0, @xType1)
                          CompilerIf Defined(IconFromDualEMF, #PB_Constant)
                            If hMeta2
                              If EnumEnhMetaFile_(hDC, hMeta2, @IconFromEMF_ColorFix(), 0, @xType2)
                                xResult = #True
                                EndIf
                              Else
                              xResult = #True
                              EndIf
                            CompilerElse
                            xResult = #True
                            CompilerEndIf
                          EndIf
                        CompilerEndIf
                      EndIf
                    EndIf
                EndIf
              SelectObject_(hDC, hBmpOld)
              If xResult
                xType3\fIcon = #True
                xResult = #False
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
                If IsMinWindowsXP
CompilerEndIf
                  bi\bV5Width >> 1
                  bi\bV5Height >> 1
                  xType3\hbmColor = CreateDIBSection_(hDC, @bi, #DIB_RGB_COLORS, @*xBmpMix, 0, 0)
                  If xType3\hbmColor
                    xType3\hbmMask = CreateBitmap_(SizeX1, SizeY1, 1, 1, 0)
                    If xType3\hbmMask
                      CompilerIf #True
                        ;xLong1 = 0;(xY * SizeX * 4) * 4
                        xLong2 = SizeX1 << 3
                        For xY = 0 To SizeY1-1
                          For xX = 0 To SizeX1-1
                            xLong3 =  PeekL(*xBmpCol + xLong1)
                            xA  = PeekL(*xBmpMsk + xLong1) & $ff
                            xRB = xLong3 & $00ff00ff
                            xG  = xLong3 & $0000ff00

                            xLong3 =  PeekL(*xBmpCol + xLong1 + xLong2)
                            xA  + (PeekL(*xBmpMsk + xLong1 + xLong2) & $ff)
                            xRB + (xLong3 & $00ff00ff)
                            xG  + (xLong3 & $0000ff00)

                            xLong1 + 4

                            xLong3 =  PeekL(*xBmpCol + xLong1)
                            xA  + (PeekL(*xBmpMsk + xLong1) & $ff)
                            xRB + (xLong3 & $00ff00ff)
                            xG  + (xLong3 & $0000ff00)

                            xLong3 =  PeekL(*xBmpCol + xLong1 + xLong2)
                            xA  + (PeekL(*xBmpMsk + xLong1 + xLong2) & $ff)
                            xRB + (xLong3 & $00ff00ff)
                            xG  + (xLong3 & $0000ff00)

                            xLong1 + 4

                            ;xA = 0
                            PokeL(*xBmpMix + (xY * SizeX1 + xX) << 2, ((xRB >> 2) & $00ff00ff) | ((xG >> 2) & $0000ff00) | ((xA >> 2) << 24))
                            Next
                          xLong1 + xLong2
                          Next
                        CompilerElse
                        For xY = 0 To SizeY1-1
                          For xX = 0 To SizeX1-1
                            xLong1 =  PeekL(*xBmpCol + (xX * SizeY * 4 + xY*2) * 4)
                            xLong1 | (PeekB(*xBmpMsk + (xX * SizeY * 4 + xY*2) * 4 + 1) << 24)
                            PokeL(*xBmpMix + (xX * SizeY1 + xY) << 2, xLong1)
                            Next
                          Next
                        CompilerEndIf

                      xResult = CreateIconIndirect_(@xType3)
                      DeleteObject_(xType3\hbmMask)
                      EndIf
                    DeleteObject_(xType3\hbmColor)
                    EndIf
CompilerIf Not #PB_Compiler_Processor = #PB_Processor_x64
                  Else
                  xType3\hbmColor = BitmapStretchCopyEx(hBmpCol, SizeX, SizeY)
                  If xType3\hbmColor
                    xType3\hbmMask = BitmapStretchCopyEx(hBmpMsk, SizeX, SizeY)
                    If xType3\hbmMask
                      xResult = CreateIconIndirect_(@xType3)
                      DeleteObject_(xType3\hbmMask)
                      EndIf
                    DeleteObject_(xType3\hbmColor)
                    EndIf
                  EndIf
CompilerEndIf
                EndIf
              EndIf
            DeleteDC_(hDC)
            EndIf
          DeleteObject_(hBmpMsk)
          EndIf
        DeleteObject_(hBmpCol)
        ElseIf hBmpMsk
        DeleteObject_(hBmpMsk)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
CompilerIf Defined(IconFromDualEMF, #PB_Constant)
  EndProcedure
CompilerElse
  EndProcedure
CompilerEndIf
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 39
; FirstLine = 36
; Folding = ----
; EnableUnicode
; EnableXP