EnableExplicit

LibBuild_Include(LoadResEx_WindowIcon_Discard)
LibBuild_Include(GetResDataPos_MultiOS)
CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
  LibBuild_Include(IconFromEMF)
  CompilerElse
  LibBuild_Include(IconFromWMF)
  CompilerEndIf

Procedure LoadResEx_WindowIconWEMF_MultiOS(hWnd, ResID, ResIDSmallFB, *ptrTrayToUpdate.NOTIFYICONDATA = 0)
  Define.i lWEMF
  Define *WEMF
  Define.i hMeta
  Define.i hIcon
  Define.i xSuccess
  Define.i xLong1
  CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
    Define.i xLong2
    CompilerEndIf

  ;If Not (GetSystemMetrics_(#SM_CXSMICON) = 16 And GetSystemMetrics_(#SM_CYSMICON) = 16 And GetSystemMetrics_(#SM_CXICON) = 32 And GetSystemMetrics_(#SM_CYICON) = 32 And ResIDSmallFB)
CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
    *WEMF = GetResDataPos_MultiOS(ResID, @"emf", @lWEMF)
    If *WEMF
      hMeta = SetEnhMetaFileBits_(lWEMF, *WEMF)
      If hMeta
        hIcon = IconFromEMF(hMeta, GetSystemMetrics_(#SM_CXSMICON), GetSystemMetrics_(#SM_CYSMICON))
CompilerElse
    *WEMF = GetResDataPos_MultiOS(ResID, @"wmf", @lWEMF)
    If *WEMF
      hMeta = SetMetaFileBitsEx_(lWEMF, *WEMF)
      If hMeta
        hIcon = IconFromWMF(hMeta, GetSystemMetrics_(#SM_CXSMICON), GetSystemMetrics_(#SM_CYSMICON))
CompilerEndIf
        If hIcon
          xSuccess = #True
          CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
            If *ptrTrayToUpdate
              xLong1 = CopyIcon_(hIcon)
              xLong2 = *ptrTrayToUpdate\hIcon
              *ptrTrayToUpdate\hIcon = xLong1
              Shell_NotifyIcon(1, *ptrTrayToUpdate)
              DestroyIcon_(xLong2)
              EndIf
            CompilerEndIf
          hIcon = SendMessage_(hWnd, $80, 0, hIcon)
          If hIcon
            DestroyIcon_(hIcon)
            EndIf
          EndIf
CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
        hIcon = IconFromEMF(hMeta, GetSystemMetrics_(#SM_CXICON), GetSystemMetrics_(#SM_CYICON))
CompilerElse
        hIcon = IconFromWMF(hMeta, GetSystemMetrics_(#SM_CXICON), GetSystemMetrics_(#SM_CYICON))
CompilerEndIf
        If hIcon
          xSuccess = #True
          hIcon = SendMessage_(hWnd, $80, 1, hIcon)
          If hIcon
            DestroyIcon_(hIcon)
            EndIf
          EndIf
        CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
          DeleteEnhMetaFile_(hMeta)
          CompilerElse
          DeleteMetaFile_(hMeta)
          CompilerEndIf
        EndIf
      ;IconFromEMF
      ;MemFree(*EMF)
      EndIf
    ;EndIf
  CompilerIf Defined(LibBuild_LoadResEx_WindowIcon_MultiOS_Included, #PB_Constant)
    If Not xSuccess
      If ResIDSmallFB
        CompilerIf Defined(LibBuild_Shell_NotifyIcon_Included, #PB_Constant)
          LoadResEx_WindowIcon_MultiOS(hWnd, ResID, ResIDSmallFB, *ptrTrayToUpdate)
          CompilerElse
          LoadResEx_WindowIcon_MultiOS(hWnd, ResID, ResIDSmallFB)
          CompilerEndIf
        EndIf
      EndIf
    CompilerEndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 76
; FirstLine = 63
; Folding = --
; EnableUnicode
; EnableXP