EnableExplicit

Structure PROPSHEETHEADER
  dwSize.l
  dwFlags.l
  hWndParent.i
  hInstance.i
  hIcon.i
  pszCaption.i
  nPages.i
  nStartPage.i
  phpage.i
  
  pnfCallback.i
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    hbmWatermark.i
    hplWatermark.i
    hbmHeader.i
    CompilerEndIf
  EndStructure

Procedure.i PropertySheetCollection_Create(MaxPages)
  Define *Mem
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    *Mem = MemAllocNC(1 + (MaxPages << 3))
    CompilerElse
    *Mem = MemAllocNC(1 + (MaxPages << 2))
    CompilerEndIf
  If *Mem
    PokeB(*Mem, 0)
    EndIf
  ProcedureReturn *Mem
  EndProcedure

Procedure.i PropertySheetCollection_Discard(*PropShetColl)
  Define.i xLong1
  Define *Mem
  If *PropShetColl
    xLong1 = PeekB(*PropShetColl)
    *Mem = *PropShetColl + 1
    While xLong1
      DestroyPropertySheetPage_(PeekI(*Mem))
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        *Mem + 8
        CompilerElse
        *Mem + 4
        CompilerEndIf
      xLong1 - 1
      Wend
    MemFree(*PropShetColl)
    EndIf
  EndProcedure

Procedure.i PropertySheetCollection_AddPage(*PropShetColl, *ResID, *CallbackProc)
  Define.i xResult
  Define.i xLong1
  Define.PROPSHEETPAGE xType1

  If *PropShetColl
    If FindResource_(hInstance, *ResID, #RT_DIALOG)
      With xType1
        \dwSize = SizeOf(PROPSHEETPAGE)
        ;\dwFlags = $1
        \hInstance = hInstance
        \pfnDlgProc = *CallBackProc
        \pResource = *ResID
        EndWith
      xResult = CreatePropertySheetPage_(@xType1)
      If xResult
        xLong1 = PeekB(*PropShetColl)

        PokeB(*PropShetColl, xLong1 + 1)
        CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
          PokeI(*PropShetColl + 1 + (xLong1 << 3), xResult)
          CompilerElse
          PokeI(*PropShetColl + 1 + (xLong1 << 2), xResult)
          CompilerEndIf
        xResult = #True
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i PropertySheetCollection_NoContextHelpHook(hWnd.i, Msg.i, *lParam)
  Define xStyle.i

  If Msg = 2
    ;DLGTEMPLATEE?
    xStyle = PeekL(*lParam)
    If (xStyle & $FFFF) = $FFFF
      ; DLGTEMPLATEEX !!!
      PokeL(*lParam + 12, PeekL(*lParam + 12) & $FFFFDFFF)
      Else
      PokeL(*lParam, xStyle & $FFFFDFFF)
      EndIf
    EndIf
  ProcedureReturn 1
  EndProcedure

Procedure PropertySheetCollection_ShowDialogOnce(*PropShetColl, hWndOwner.i, Caption.s = "", CallBackProc.i = 0, ContextHelp.i = #False)
  Define.i xLong1
  Define.PROPSHEETHEADER xType1

  If *PropShetColl
    xLong1 = PeekB(*PropShetColl)
    If xLong1
      With xType1
        \dwSize = SizeOf(PROPSHEETHEADER)
        \nPages = xLong1
        \hInstance = hInstance
        \hWndParent = hWndOwner
        \phpage = *PropShetColl + 1
        If Not ContextHelp
          \pnfCallback = @PropertySheetCollection_NoContextHelpHook()
          EndIf
        If Len(Caption)
          xType1\pszCaption = @Caption
          EndIf
        EndWith
      PropertySheet_(@xType1)
      PokeB(*PropShetColl, 0)
      EndIf
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 49
; FirstLine = 46
; Folding = --
; EnableUnicode
; EnableXP