﻿EnableExplicit

LibBuild_Include(TxtFileReader_Core)

Procedure.i TxtFileReader_LBParser(*ptrStringW, *ptrLenOut)
  Define.i xResult

  EnableASM
    CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      mov rax, *ptrStringW
      push rsi
      mov rsi, rax
      !xor rax, rax
      !xor rcx, rcx
  
      cld
;Search for CR
!TxtFileReader_LBParser_Loop1:
      lodsw
      !or ax, ax
      jz TxtFileReader_LBParser_EndOfString
      cmp ax, $0d
      je TxtFileReader_LBParser_FoundCR
      cmp ax, $0a
      jne TxtFileReader_LBParser_Loop1

; LF   / 0A   / 10
      mov rcx, 2
      sub rsi, rcx
      jmp TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCR:
; CR   / 0D   / 13
; CRLF / 0D0A / 1310
; Test if LF
      lodsw
      cmp ax, $0a
      je TxtFileReader_LBParser_FoundCRFL

; CR   / 0D   / 13
      mov rcx, 2
      sub rsi, 4
      jmp TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCRFL:
; CRLF / 0D0A / 1310
      mov rcx, 4
      sub rsi, rcx

!TxtFileReader_LBParser_Found:
      mov rax, rsi

!TxtFileReader_LBParser_EndOfString:
      pop rsi
    
      mov xResult, rax
      mov *ptrStringW, rcx
      PokeL(*ptrLenOut, *ptrStringW)
      CompilerElse
      mov eax, *ptrStringW
      push esi
      mov esi, eax
      !xor eax, eax
      !xor ecx, ecx
  
      cld
;Search for CR
!TxtFileReader_LBParser_Loop1:
      lodsw
      !or ax, ax
      jz TxtFileReader_LBParser_EndOfString
      cmp ax, $0d
      je TxtFileReader_LBParser_FoundCR
      cmp ax, $0a
      jne TxtFileReader_LBParser_Loop1

; LF   / 0A   / 10
      mov ecx, 2
      sub esi, ecx
      jmp TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCR:
; CR   / 0D   / 13
; CRLF / 0D0A / 1310
; Test if LF
      lodsw
      cmp ax, $0a
      je TxtFileReader_LBParser_FoundCRFL

; CR   / 0D   / 13
      mov ecx, 2
      sub esi, 4
      jmp TxtFileReader_LBParser_Found

!TxtFileReader_LBParser_FoundCRFL:
; CRLF / 0D0A / 1310
      mov ecx, 4
      sub esi, ecx

!TxtFileReader_LBParser_Found:
      mov eax, esi

!TxtFileReader_LBParser_EndOfString:
      pop esi
    
      mov xResult, eax
      mov *ptrStringW, ecx
      PokeL(*ptrLenOut, *ptrStringW)
      CompilerEndIf
    DisableASM
  ProcedureReturn xResult
  EndProcedure

;boolean -> ptrstr (ptrtemp?)
Procedure.i TxtFileReader_NextLine(*hTxtFileIn.TxtFileReadStruct)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2

  If *hTxtFileIn
    If *hTxtFileIn\hMem And Not *hTxtFileIn\hMemPos = *hTxtFileIn\hMemEnd
      *hTxtFileIn\LastPos = *hTxtFileIn\hMemPos
      xLong1 = TxtFileReader_LBParser(*hTxtFileIn\hMemPos, @xLong2)
      If xLong1
        *hTxtFileIn\LastEnd = xLong1
        *hTxtFileIn\hMemPos = xLong1 + xLong2
        xResult = #True
        Else
        *hTxtFileIn\LastEnd = *hTxtFileIn\LastPos
        MemFree(*hTxtFileIn\hMem)
        *hTxtFileIn\hMem = 0
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s TxtFileReader_GetLineString(*hTxtFileIn.TxtFileReadStruct)
  Define.s xResult
  If *hTxtFileIn
    If *hTxtFileIn\LastPos And *hTxtFileIn\LastEnd
      If Not *hTxtFileIn\LastPos = *hTxtFileIn\LastEnd
        xResult = PeekS(*hTxtFileIn\LastPos, (*hTxtFileIn\LastEnd - *hTxtFileIn\LastPos) >> 1, #PB_Unicode)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 111
; FirstLine = 93
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory