EnableExplicit

Prototype WSAStartup(wVersionRequested, *lpWSAData) 
Prototype WSACreateEvent()
Prototype WSAEventSelect(Socket.i, hEvent.i, lNetworkEvents.i) 
Prototype WSACloseEvent(hEvent.i) 
Prototype WSAWaitForMultipleEvents(EventNum.i, *lphEvents, fWaitAll.b, dwTimeout.i, fAlertable)

Procedure.i WinSock_Base_LibBuildPostInit()
  Global WSAStartup.WSAStartup
  Global WSACreateEvent.WSACreateEvent
  Global WSAEventSelect.WSAEventSelect
  Global WSACloseEvent.WSACloseEvent
  Global WSAWaitForMultipleEvents.WSAWaitForMultipleEvents
  Global WS2_32_Module.i
  Global WinSock_Inited.i

  ws2_32_Module = LoadLibrary_("ws2_32.dll")
  If ws2_32_Module
    WSAStartup = GetProcAddress(ws2_32_Module, "WSAStartup") 
    WSACreateEvent = GetProcAddress(ws2_32_Module, "WSACreateEvent") 
    WSAEventSelect = GetProcAddress(ws2_32_Module, "WSAEventSelect") 
    WSACloseEvent = GetProcAddress(ws2_32_Module, "WSACloseEvent") 
    WSAWaitForMultipleEvents = GetProcAddress(ws2_32_Module, "WSAWaitForMultipleEvents")
    If Not (WSAStartup And WSACreateEvent And WSAEventSelect And WSACloseEvent And WSAWaitForMultipleEvents)
      WS2_32_Module = 0
      EndIf
    EndIf
  EndProcedure

Procedure.i WinSock_Init()
  Define.WSAData WSAInfo

  If Not WinSock_Inited
    If ws2_32_Module
      If WSAStartup($101, @WSAInfo) = 0
        WinSock_Inited = #True
        EndIf
      EndIf
    EndIf
  ProcedureReturn WinSock_Inited
  EndProcedure

Procedure WinSock_Close()
  If WinSock_Inited
    WSACleanup_()
    WinSock_Inited = #True
    EndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 7
; FirstLine = 3
; Folding = -
; EnableUnicode
; EnableXP