EnableExplicit

; Optional: #WinSock_HTTPReceiverMT_AbortAll
; Optional: #WinSock_HTTPReceiverMT_GetThreadBufferStatus
; Optional: #WinSock_HTTPReceiverMT_CreateThreadFromReceiver
; Optional: #WinSock_HTTPReceiverMT_CreateThreadFromURL
; Optional: #WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus
; Optional: #WinSock_HTTPReceiverMT_CreateSaveThreadFromURL

; 

CompilerIf Not Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
  CompilerIf Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
    #WinSock_HTTPReceiverMT_CreateThreadFromURL = #True
    CompilerEndIf
  CompilerEndIf




CompilerIf Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
  LibBuild_Include(RegisterClass)
  CompilerEndIf
CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromReceiver, #PB_Constant)
  LibBuild_Include(GetTickCountAPI)
  CompilerEndIf
CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
  LibBuild_Include(WinSock_ConnectAndRequestHTTP)
  LibBuild_Include(MemAlloc_FromString)
  CompilerEndIf
LibBuild_Include(WinSock_HTTPReceiver)
CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
  LibBuild_Include(WinSock_HTTPReceiver_GetBufferStatus)
  CompilerEndIf

;CompilerIf Not Defined(WinSock_HTTPReceiverMT_Base_NoWarn_CreateThreadFromURL, #PB_Constant)
;  LibBuild_CheckPriority(WinSock_HTTPReceiverMT_CreateThreadFromURL)
;  CompilerEndIf


Procedure.i WinSock_HTTPReceiverMT_LibBuildPostInit()
  Structure WinSock_HTTPReceiverMT_Struct
    hRecv.i
    xProc.i
    xParam.i
    CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
      ptrURL.i
      InitFlags.i
      InitPort.i
      InitTimeout.i
      CompilerEndIf
    CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
      SaveThread.i
      CompilerEndIf
    EndStructure
  Global WinSock_HTTPReceiverMT_NumThreads.i
  Global WinSock_HTTPReceiverMT_Mutex.i
  Global WinSock_HTTPReceiverMT_QuitNow.i

  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    Structure WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus_Struct
      SaveJobs.i
      SaveThreadsCount.i
      SaveThreadsBytesUsed.q
      SaveThreadsBytesAllocated.q
      AllThreadsCount.i
      AllThreadsBytesUsed.q
      AllThreadsBytesAllocated.q
      SaveFailQueueCount.i
      SaveProgQueueCount.i
      SaveFinishQueueCount.i
      SaveFinishQueueBytesUsed.q
      SaveFinishQueueBytesAllocated.q
      EndStructure
  
    Global WinSock_HTTPReceiverMT_NumSaveThreads.i
    Global WinsockHTTPReceiverMT_SaveQueueCountReal.i
    Global WinSock_HTTPReceiverMT_StatusBufferedSave.q
    Global WinSock_HTTPReceiverMT_StatusAllocatedSave.q

    Global WinsockHTTPReceiverMT_SaveQueueCountFail.i
    Global WinsockHTTPReceiverMT_SaveQueueCountProg.i
    Global WinsockHTTPReceiverMT_SaveQueueCountDone.i
    Global WinsockHTTPReceiverMT_SaveQueueCountUsed.q
    Global WinsockHTTPReceiverMT_SaveQueueCountAllc.q
    
    CompilerEndIf

  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
    Global WinSock_HTTPReceiverMT_StatusBuffered.q
    Global WinSock_HTTPReceiverMT_StatusAllocated.q
    CompilerEndIf


  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
    Structure ctLibWinsockHTTPReceiverMTNThreadHlpStruct
      RealProc.i
      RealParam.i
      LastProg.i
      CurHRecv.i
      CurWParam1.i
      CurLParam2.i
      StsBUsed.i
      StsBAlloc.i
      CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
        SizeUsedLast.i
        SizeAllocLast.i
        CompilerEndIf
      EndStructure
    CompilerEndIf
  CompilerIf Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
    Global WinsockHTTPReceiverMT_SaveWindowHwnd.i
    Global WinsockHTTPReceiverMT_SaveWindowMsgID.i
    
    #WinsockHTTPReceiverMT_SaveWindowClass = "ctLibWinsockHTTPReceiverMTNThreadHelper"
    WinsockHTTPReceiverMT_SaveWindowMsgID = RegisterWindowMessage_(@"CTLIB_WSHTTPRMTNTHLP")
    CompilerEndIf
  EndProcedure

Procedure.i WinSock_HTTPReceiverMT_FetchThread(*lParam.WinSock_HTTPReceiverMT_Struct)
  Define.i xLong1
  Define.i xLong2
  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
    Define.i SizeUsedLast
    Define.i SizeAllocLast
    Define.i SizeUsedNow
    Define.i SizeAllocNow
    CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
      Define.i WasSaveThread
      Define.ctLibWinsockHTTPReceiverMTNThreadHlpStruct *xSaveParam
      CompilerEndIf
    CompilerEndIf

CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
  ;Define.i CloseWS
  ;Define.WSAData WSAInfo

  If *lParam\ptrURL
    ;If ws2_32_Module
    ;  If WSAStartup($101, @WSAInfo) = 0
        ;CloseWS = #True
        xLong1 = WinSock_ConnectAndRequestHTTP(PeekS(*lParam\ptrURL), *lParam\InitPort, *lParam\InitTimeout)
        MemFree(*lParam\ptrURL)
        If xLong1
          *lParam\hRecv = WinSock_HTTPReceiver_Create(xLong1, *lParam\InitFlags, *lParam\InitTimeout)
          EndIf
        If Not *lParam\hRecv
          CallFunctionFast(*lParam\xProc, 0, 0, 0, 2, *lparam\xParam)
          EndIf
        ;EndIf
      ;EndIf
    EndIf
  If *lParam\hRecv
CompilerEndIf

    CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
      SizeAllocNow = #LibBuild_EstMemOverHeadBytesPerAlloc + SizeOf(WinSock_HTTPReceiverBuffer)
      LockMutex(WinSock_HTTPReceiverMT_Mutex)
      WinSock_HTTPReceiverMT_StatusAllocated + SizeAllocNow
      CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
        WinSock_HTTPReceiverMT_StatusAllocatedSave + SizeAllocNow
        CompilerEndIf
      UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
      CompilerEndIf
    CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
      If *lParam\SaveThread
        *xSaveParam = *lParam\xParam
        *xSaveParam\SizeAllocLast = SizeAllocNow
        EndIf
      CompilerEndIf

;OutputDebugString_("hReceiverTI: " + Hex(*lParam\hRecv) + "/" + Str(*lParam\hRecv))

  ; 0 = aborted / timeout ... errors
  ; 1 = processing
  ; 2 = ok
    Repeat
      Sleep_(333)
      CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
        WinSock_HTTPReceiver_GetBufferStatus(*lParam\hRecv, @SizeUsedNow, @SizeAllocNow)
        If SizeUsedNow > SizeUsedLast Or SizeAllocNow > SizeAllocLast
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            If *lParam\SaveThread
              *xSaveParam = *lParam\xParam
              *xSaveParam\SizeUsedLast - SizeUsedLast + SizeUsedNow
              *xSaveParam\SizeAllocLast - SizeAllocLast + SizeAllocNow
              EndIf
            CompilerEndIf
          LockMutex(WinSock_HTTPReceiverMT_Mutex)
          WinSock_HTTPReceiverMT_StatusBuffered - SizeUsedLast + SizeUsedNow
          WinSock_HTTPReceiverMT_StatusAllocated - SizeAllocLast + SizeAllocNow
          ;OutputDebugString_("UpdateNow?")
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            ;OutputDebugString_(Str(WinSock_HTTPReceiverMT_StatusBufferedSave) + "  add " + Str(SizeUsedNow) + " sub " + Str(SizeUsedLast))
            WinSock_HTTPReceiverMT_StatusBufferedSave - SizeUsedLast + SizeUsedNow
            WinSock_HTTPReceiverMT_StatusAllocatedSave - SizeAllocLast + SizeAllocNow
            CompilerEndIf
          UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
          SizeUsedLast = SizeUsedNow
          SizeAllocLast = SizeAllocNow
          EndIf
        CompilerEndIf
      If WinSock_HTTPReceiverMT_QuitNow
        CallFunctionFast(*lParam\xProc, 0, 0, #True, 0, *lParam\xParam)
        Break
        EndIf

      If Winsock_HTTPReceiver_GetStatus(*lParam\hRecv, @xLong1, @xLong2)
        xLong1 = Winsock_HTTPReceiver_GetCompleteDataPos(*lParam\hRecv, @xLong2)
;Debug "Call12"
        If xLong1 And xLong2
          CallFunctionFast(*lParam\xProc, @*lParam\hRecv, 2, xLong1, xLong2, *lParam\xParam)
          Else
          CallFunctionFast(*lParam\xProc, 0, 0, #False, 0, *lParam\xParam)
          EndIf
;Debug "Done12"
        Break
        Else
;Debug "Call34"
        If xLong2 > 0 
          CallFunctionFast(*lParam\xProc, 0, 1, xLong1, xLong2, *lParam\xParam)
          ElseIf xLong1 > #Winsock_HTTPReceiverMaxHeaderSize
          CallFunctionFast(*lParam\xProc, 0, 1, xLong1, 0, *lParam\xParam)
          EndIf
;Debug "Done34"
        EndIf
      ForEver
    If *lParam\hRecv
      Winsock_HTTPReceiver_Destroy(*lParam\hRecv)
      EndIf
CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
    EndIf
  ;If CloseWS
    ;WSACleanup_()
    ;EndIf
CompilerEndIf

  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    WasSaveThread = *lParam\SaveThread
    CompilerEndIf
  MemFree(*lParam)
  LockMutex(WinSock_HTTPReceiverMT_Mutex)
  WinSock_HTTPReceiverMT_NumThreads - 1
  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) Or Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
    CompilerIf Not #WinSock_HTTPReceiverMT_LeakTest
      WinSock_HTTPReceiverMT_StatusBuffered - SizeUsedLast
      WinSock_HTTPReceiverMT_StatusAllocated - SizeAllocLast
      CompilerEndIf
    CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
      WinSock_HTTPReceiverMT_NumSaveThreads - WasSaveThread
      CompilerEndIf
    CompilerEndIf
  UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
;OutputDebugString_("QuitThread " + Str(*lParam\hRecv))
  ;DoAnimateReadDir(0, -1)
  EndProcedure

Procedure.i WinSock_HTTPReceiverMT_RealCreateThreadEx(*lParam.WinSock_HTTPReceiverMT_Struct)
  Define.i xResult
  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    Define.i IsSaveThread
    CompilerEndIf

  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    IsSaveThread = *lParam\SaveThread
    CompilerEndIf
  
  If WinSock_HTTPReceiverMT_Mutex
    LockMutex(WinSock_HTTPReceiverMT_Mutex)
    WinSock_HTTPReceiverMT_NumThreads + 1
    CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
      WinSock_HTTPReceiverMT_NumSaveThreads + IsSaveThread
      CompilerEndIf
    UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
    ;xBool1 = #True
    Else
    WinSock_HTTPReceiverMT_Mutex = CreateMutex()
    If WinSock_HTTPReceiverMT_Mutex
      WinSock_HTTPReceiverMT_NumThreads = 1
      CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
        WinSock_HTTPReceiverMT_NumSaveThreads = IsSaveThread
        CompilerEndIf
      EndIf
    EndIf

  If WinSock_HTTPReceiverMT_Mutex
    xResult = CreateThread(@WinSock_HTTPReceiverMT_FetchThread(), *lParam)
    If Not xResult
      LockMutex(WinSock_HTTPReceiverMT_Mutex)
      WinSock_HTTPReceiverMT_NumThreads - 1
      CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
        WinSock_HTTPReceiverMT_NumSaveThreads - IsSaveThread
        CompilerEndIf
      UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
      EndIf
    EndIf

  If Not xResult
    CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
      If *lParam\ptrURL
        CallFunctionFast(*lParam\xProc, 0, 0, 0, 1, *lparam\xParam)
        MemFree(*lParam\ptrURL)
        Else
        WinSock_HTTPReceiver_Destroy(*lParam\hRecv)
        EndIf
      CompilerElse
      WinSock_HTTPReceiver_Destroy(*lParam\hRecv)
      CompilerEndIf
    MemFree(*lParam)
    EndIf
  ProcedureReturn xResult
  EndProcedure

CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
  Procedure WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus(*xParam.WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus_Struct)
    Define.i xResult
  
    If WinSock_HTTPReceiverMT_Mutex
      LockMutex(WinSock_HTTPReceiverMT_Mutex)
      With *xParam
        \SaveJobs = WinsockHTTPReceiverMT_SaveQueueCountReal
        \SaveThreadsCount = WinSock_HTTPReceiverMT_NumSaveThreads
        \SaveThreadsBytesUsed = WinSock_HTTPReceiverMT_StatusBufferedSave
        \SaveThreadsBytesAllocated = WinSock_HTTPReceiverMT_StatusAllocatedSave
        \AllThreadsCount = WinSock_HTTPReceiverMT_NumThreads
        \AllThreadsBytesUsed = WinSock_HTTPReceiverMT_StatusBuffered
        \AllThreadsBytesAllocated = WinSock_HTTPReceiverMT_StatusAllocated
        \SaveFailQueueCount = WinsockHTTPReceiverMT_SaveQueueCountFail
        \SaveProgQueueCount = WinsockHTTPReceiverMT_SaveQueueCountProg
        \SaveFinishQueueCount = WinsockHTTPReceiverMT_SaveQueueCountDone
        \SaveFinishQueueBytesUsed = WinsockHTTPReceiverMT_SaveQueueCountUsed
        \SaveFinishQueueBytesAllocated = WinsockHTTPReceiverMT_SaveQueueCountAllc
        EndWith
      xResult = #True
      UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
      EndIf
    ProcedureReturn xResult
    EndProcedure
  CompilerEndIf











CompilerIf Defined(WinSock_HTTPReceiverMT_AbortAll, #PB_Constant)
  Procedure WinSock_HTTPReceiverMT_AbortAll()
    CompilerIf Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
      Define.MSG xMsg
      CompilerEndIf
  
    WinSock_HTTPReceiverMT_QuitNow = #True
    While WinSock_HTTPReceiverMT_NumThreads
      Sleep_(100)
      ;doevents()
      Wend
    CompilerIf Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
      ;OutputDebugString_("Discard from queue...")
      ;OutputDebugString_("  Failed: " + Str(WinsockHTTPReceiverMT_SaveQueueCount)
      If WinsockHTTPReceiverMT_SaveWindowHwnd
        While PeekMessage_(@xMsg, WinsockHTTPReceiverMT_SaveWindowHwnd, WinsockHTTPReceiverMT_SaveWindowMsgID, WinsockHTTPReceiverMT_SaveWindowMsgID, #PM_REMOVE)
          ;OutputDebugString_("removed 1x, translating...")
          TranslateMessage_(@xMsg)
          Wend
        EndIf
      ;OutputDebugString_("Discarding done...")
      CompilerEndIf
    WinSock_HTTPReceiverMT_QuitNow = #False
    EndProcedure
  CompilerEndIf













CompilerIf Defined(WinSock_HTTPReceiverMT_GetThreadBufferStatus, #PB_Constant)
  Procedure WinSock_HTTPReceiverMT_GetThreadBufferStatus(*NumThreads, *BytesUsedQ, *BytesAllocatedQ)
    Define.i nThreads
    Define.q BytesUsed
    Define.q BytesAlloc
    Define.i xResult
  
    If WinSock_HTTPReceiverMT_Mutex
      LockMutex(WinSock_HTTPReceiverMT_Mutex)
      nThreads = WinSock_HTTPReceiverMT_NumThreads
      BytesUsed = WinSock_HTTPReceiverMT_StatusBuffered
      BytesAlloc = WinSock_HTTPReceiverMT_StatusAllocated
      xResult = #True
      UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
      EndIf
  
    If *NumThreads
      PokeI(*NumThreads, nThreads)
      EndIf
    If *BytesUsedQ
      PokeQ(*BytesUsedQ, BytesUsed)
      EndIf
    If *BytesAllocatedQ
      PokeQ(*BytesAllocatedQ, BytesAlloc + nThreads * (#LibBuild_EstMemOverHeadBytesPerAlloc + SizeOf(WinSock_HTTPReceiverMT_Struct)))
      EndIf
    ProcedureReturn xResult
    EndProcedure
  CompilerEndIf











CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromReceiver, #PB_Constant)
  Procedure.i WinSock_HTTPReceiverMT_CreateThreadFromReceiver(hReceiver.i, *Proc, *xParam)
    Define.i xResult
    Define *Mem.WinSock_HTTPReceiverMT_Struct
  
    If hReceiver And *Proc
      *Mem = MemAlloc(SizeOf(WinSock_HTTPReceiverMT_Struct))
      If *Mem
        *Mem\hRecv = hReceiver
        *Mem\xProc = *Proc
        *Mem\xParam = *xParam
        xResult = WinSock_HTTPReceiverMT_RealCreateThreadEx(*Mem)
        EndIf
      EndIf
    ProcedureReturn xResult
    EndProcedure
  CompilerEndIf









CompilerIf Defined(WinSock_HTTPReceiverMT_CreateThreadFromURL, #PB_Constant)
  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    Procedure.i WinSock_HTTPReceiverMT_CreateThreadFromURLInt(*Proc, *xParam, URL.s, Port.i, Flags.i, TimeOut.i, IsSaveThread.i)
  CompilerElse  
    Procedure.i WinSock_HTTPReceiverMT_CreateThreadFromURL(*Proc, *xParam, URL.s, Port.i = 80, Flags.i = 0, TimeOut.i = 4000)
  CompilerEndIf
    Define.i xResult
    Define *Mem.WinSock_HTTPReceiverMT_Struct
  
    If *Proc
      *Mem = MemAlloc(SizeOf(WinSock_HTTPReceiverMT_Struct))
      If *Mem
        *Mem\ptrURL = MemAlloc_FromString(URL, Len(URL))
        If *Mem\ptrURL
          *Mem\hRecv = 0
          *Mem\xProc = *Proc
          *Mem\xParam = *xParam
          *Mem\InitPort = Port
          *Mem\InitFlags = Flags
          *Mem\InitTimeout = TimeOut
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            *Mem\SaveThread = IsSaveThread
            CompilerEndIf
          xResult = WinSock_HTTPReceiverMT_RealCreateThreadEx(*Mem)
          Else
          MemFree(*Mem)
          EndIf
        EndIf
      EndIf
    ProcedureReturn xResult
  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    EndProcedure
  CompilerElse
    EndProcedure
  CompilerEndIf
  
  CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
    Procedure.i WinSock_HTTPReceiverMT_CreateThreadFromURL(*Proc, *xParam, URL.s, Port.i = 80, Flags.i = 0, TimeOut.i = 4000)
      ProcedureReturn WinSock_HTTPReceiverMT_CreateThreadFromURLInt(*Proc, *xParam, URL, Port, Flags, TimeOut, 0)
      EndProcedure
    CompilerEndIf
  CompilerEndIf

















CompilerIf Defined(WinSock_HTTPReceiverMT_CreateSaveThreadFromURL, #PB_Constant)
  Procedure.i WinsockHTTPReceiverMT_SaveWindowProc(hWnd.i, Msg.i, StatusType.i, *CustParam.ctLibWinsockHTTPReceiverMTNThreadHlpStruct)
    ;Debug "WindowMSG: " + Str(hwnd) + ", " + Str(Msg) + ", " + Str(StatusType) + ", " + Str(*CustParam)
    If Msg = WinsockHTTPReceiverMT_SaveWindowMsgID And *CustParam
      ;OutputDebugString_("Message " + Str(*CustParam\RealParam))
      ;Debug "CallBack 2 (" + Str(StatusType) + "): " + Str(*CustParam\CurWParam1) + "/" + Str(*CustParam\CurLParam2) + " param " + Str(*CustParam\RealParam)
      Select StatusType
        Case 0
          ;If *CustParam\CurWParam1
            ;OutputDebugString_("Manually Aborted")
            ;Else
            ;OutputDebugString_("Failed / timeout")
            ;EndIf
          ;Debug "StartCallBack to " + Hex(*CustParam\RealProc) + "/" + Str(*CustParam\RealProc)
          CallFunctionFast(*CustParam\RealProc, StatusType, *CustParam\CurWParam1, *CustParam\CurLParam2, *CustParam\RealParam)
          MemFree(*CustParam)
  ;OutputDebugString_("Dec Queue")
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            LockMutex(WinSock_HTTPReceiverMT_Mutex)
            CompilerIf Not #WinSock_HTTPReceiverMT_LeakTest
              WinsockHTTPReceiverMT_SaveQueueCountFail - 1
              CompilerEndIf
            WinsockHTTPReceiverMT_SaveQueueCountReal - 1
            UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
            CompilerEndIf
        Case 1
            ;If *CustParam\CurLParam2
            ;  OutputDebugString_("Progress: " + Str(*CustParam\CurWParam1) + "/" + Str(*CustParam\CurLParam2))
            ;  Else
            ;  OutputDebugString_("Undetermined")
            ;  EndIf
          ;Debug "StartCallBack to " + Hex(*CustParam\RealProc) + "/" + Str(*CustParam\RealProc)
          CallFunctionFast(*CustParam\RealProc, StatusType, *CustParam\CurWParam1, *CustParam\CurLParam2, *CustParam\RealParam)
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant) And Not #WinSock_HTTPReceiverMT_LeakTest
            LockMutex(WinSock_HTTPReceiverMT_Mutex)
            WinsockHTTPReceiverMT_SaveQueueCountProg - 1
            UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
            CompilerEndIf
        Case 2
          ;OutputDebugString_("Finished: " + Str(*CustParam\CurWParam1) + "/" + Str(*CustParam\CurLParam2))
          ;Debug "StartCallBack to " + Hex(*CustParam\RealProc) + "/" + Str(*CustParam\RealProc)
          CallFunctionFast(*CustParam\RealProc, StatusType, *CustParam\CurWParam1, *CustParam\CurLParam2, *CustParam\RealParam)
          Winsock_HTTPReceiver_Destroy(*CustParam\CurHRecv)
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            Msg = *CustParam\CurLParam2
            StatusType = *CustParam\StsBAlloc
            CompilerEndIf
          MemFree(*CustParam)
  ;OutputDebugString_("Dec Queue")
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            LockMutex(WinSock_HTTPReceiverMT_Mutex)
            WinsockHTTPReceiverMT_SaveQueueCountReal - 1
            CompilerIf Not #WinSock_HTTPReceiverMT_LeakTest
              WinsockHTTPReceiverMT_SaveQueueCountDone - 1
              WinsockHTTPReceiverMT_SaveQueueCountUsed - Msg
              WinsockHTTPReceiverMT_SaveQueueCountAllc - StatusType
              CompilerEndIf
            UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
            CompilerEndIf
        EndSelect
      Else
      ProcedureReturn DefWindowProc_(hWnd, Msg, StatusType, *CustParam)
      EndIf
    EndProcedure
  
  Procedure.i WinsockHTTPReceiverMT_SaveThreadProc(*ptrHRecv, StatusType.i, wParam1.i, lParam2.i, *CustParam.ctLibWinsockHTTPReceiverMTNThreadHlpStruct)
    If *CustParam And WinsockHTTPReceiverMT_SaveWindowHwnd
  ;OutputDebugString_("Callback " + Str(*CustParam\RealParam))
      Select StatusType
        Case 0
          ;If lParam2
            ;Debug "Manually Aborted"
            ;Else
            ;Debug "Failed / timeout"
            ;EndIf
          *CustParam\CurWParam1 = wParam1
          *CustParam\CurLParam2 = lParam2
  ;OutputDebugString_("Inc Queue")
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            LockMutex(WinSock_HTTPReceiverMT_Mutex)
            WinsockHTTPReceiverMT_SaveQueueCountFail + 1
            CompilerIf Not #WinSock_HTTPReceiverMT_LeakTest
              ;OutputDebugString_(Str(WinSock_HTTPReceiverMT_StatusBufferedSave) + " 0sub " + Str(*CustParam\SizeUsedLast))
              WinSock_HTTPReceiverMT_StatusBufferedSave - *CustParam\SizeUsedLast
              WinSock_HTTPReceiverMT_StatusAllocatedSave - *CustParam\SizeAllocLast
              CompilerEndIf
            UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
            CompilerEndIf
          SendNotifyMessage_(WinsockHTTPReceiverMT_SaveWindowHwnd, WinsockHTTPReceiverMT_SaveWindowMsgID, StatusType, *CustParam)
        Case 1
            ;If wParam1
            ;  Debug "Progress: " + Str(wParam1) + "/" + Str(lParam2)
            ;  Else
            ;  Debug "Undetermined"
            ;  EndIf
          If IsTickTimeElapsedMS(*CustParam\LastProg, 1000) Or (lParam2 And wParam1 = lParam2)
            *CustParam\CurWParam1 = wParam1
            *CustParam\CurLParam2 = lParam2
            *CustParam\LastProg = GetTickTimeMS()
  ;Debug "Sending Progress"
            CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
              LockMutex(WinSock_HTTPReceiverMT_Mutex)
              WinsockHTTPReceiverMT_SaveQueueCountProg + 1
              UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
              CompilerEndIf
            SendNotifyMessage_(WinsockHTTPReceiverMT_SaveWindowHwnd, WinsockHTTPReceiverMT_SaveWindowMsgID, StatusType, *CustParam)
            EndIf
        Case 2
          ;Debug "Finished downloading " + Str(lParam2) + " bytes, String: " + PeekS(wParam1, 8, #PB_Ascii)
          ;CallFunctionFast(*CustParam\RealProc, StatusType, wParam1, lParam2, *CustParam\RealParam)
          *CustParam\CurHRecv = PeekI(*ptrHRecv)
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            WinSock_HTTPReceiver_GetBufferStatus(*CustParam\CurHRecv, @*CustParam\StsBUsed, @*CustParam\StsBAlloc)
            CompilerEndIf
          PokeI(*ptrHRecv, 0)
          *CustParam\CurWParam1 = wParam1
          *CustParam\CurLParam2 = lParam2
  ;OutputDebugString_("Inc Queue")
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            LockMutex(WinSock_HTTPReceiverMT_Mutex)
            WinsockHTTPReceiverMT_SaveQueueCountDone + 1
            CompilerIf Not #WinSock_HTTPReceiverMT_LeakTest
              ;OutputDebugString_(Str(WinSock_HTTPReceiverMT_StatusBufferedSave) + " 2sub " + Str(*CustParam\SizeUsedLast))
              WinSock_HTTPReceiverMT_StatusBufferedSave - *CustParam\SizeUsedLast
              WinSock_HTTPReceiverMT_StatusAllocatedSave - *CustParam\SizeAllocLast
              CompilerEndIf
            WinsockHTTPReceiverMT_SaveQueueCountUsed + lParam2
            WinsockHTTPReceiverMT_SaveQueueCountAllc + *CustParam\StsBAlloc
            UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
            CompilerEndIf
  ;Debug "Sending Finished"
          SendNotifyMessage_(WinsockHTTPReceiverMT_SaveWindowHwnd, WinsockHTTPReceiverMT_SaveWindowMsgID, StatusType, *CustParam)
          ;CallFunctionFast(*CustParam\RealProc, StatusType, wParam1, lParam2, *CustParam\RealParam)
          ;MemFree(CustParam)
          ;CallFunctionFast(*CustParam\RealProc, StatusType, wParam1, lParam2, *CustParam\RealParam)
        EndSelect
      EndIf
    EndProcedure
  
  Procedure.i WinSock_HTTPReceiverMT_CreateSaveThreadFromURL(*Proc, *xParam, URL.s, Port.i = 80, Flags.i = 0, TimeOut.i = 4000)
    Define.i xLong1
    Define.s xChar1
    Define *Mem.ctLibWinsockHTTPReceiverMTNThreadHlpStruct
    
    *Mem = MemAlloc(SizeOf(ctLibWinsockHTTPReceiverMTNThreadHlpStruct))
    If *Mem
      If WinSock_Init()
        If Not WinsockHTTPReceiverMT_SaveWindowHwnd
          xChar1 = #WinsockHTTPReceiverMT_SaveWindowClass
          RegisterClass(@xChar1, @WinsockHTTPReceiverMT_SaveWindowProc(), #CS_NOCLOSE, 0)
          WinsockHTTPReceiverMT_SaveWindowHwnd = CreateWindowEx_($88, @xChar1, 0, #WS_POPUP, -6000, -6000, 32, 16, 0, 0, hInstance, 0)
          EndIf
        If WinsockHTTPReceiverMT_SaveWindowHwnd  
          *Mem\RealProc = *Proc
          *Mem\RealParam = *xParam
          *Mem\LastProg = GetTickTimeMS()
  
          CompilerIf Defined(WinSock_HTTPReceiverMT_GetSaveThreadBufferQueueStatus, #PB_Constant)
            ;*Mem\SaveThread = 1 ; will be added to inc internally!
            If WinSock_HTTPReceiverMT_Mutex
              LockMutex(WinSock_HTTPReceiverMT_Mutex)
              WinsockHTTPReceiverMT_SaveQueueCountReal + 1
              UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
              Else
              WinsockHTTPReceiverMT_SaveQueueCountReal = 1
              EndIf
            xLong1 = WinSock_HTTPReceiverMT_CreateThreadFromURLInt(@WinsockHTTPReceiverMT_SaveThreadProc(), *Mem, URL, Port, Flags, TimeOut, 1)
            If Not xLong1
              If WinSock_HTTPReceiverMT_Mutex
                LockMutex(WinSock_HTTPReceiverMT_Mutex)
                WinsockHTTPReceiverMT_SaveQueueCountReal - 1
                UnlockMutex(WinSock_HTTPReceiverMT_Mutex)
                Else
                WinsockHTTPReceiverMT_SaveQueueCountReal - 1
                EndIf
              EndIf
            CompilerElse
            xLong1 = WinSock_HTTPReceiverMT_CreateThreadFromURL(@WinsockHTTPReceiverMT_SaveThreadProc(), *Mem, URL, Port, Flags, TimeOut)
            CompilerEndIf
          EndIf
        EndIf
      If Not xLong1
        MemFree(*Mem)
        EndIf
      EndIf
    ProcedureReturn xLong1
    EndProcedure
  CompilerEndIf

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 147
; FirstLine = 147
; Folding = ------------
; EnableUnicode
; EnableXP