﻿; Calaym - Media player GUI for sound systems
; Copyright (C) 2002-2014 Jan Vorel
;
; You can redistribute the official software packages under the terms of the
; User-friendly Distribution License Version 2.00, published by Jan Vorel
;
; You can use this software under the terms of the
; User-friendly Open-source License Version 1.00, published by Jan Vorel
;
; You should have received copies of the licenses along with this program. If
; not, contact the author.
;
; If you want to use or distribute this software under a different license, ask
; the author.
;
; The software is provided "as is" without warrenty of any kind. The Licensor
; cannot be held responsible for any damage caused by using, extracting or
; installing the software.

EnableExplicit

#LayerVersionID = $10001101
Global *ctSSLayer_hDLL
Global *ctSSLayer_CanUseItemInt
Global *ctSSLayer_CloseInt
Global *ctSSLayer_DllReleaseInt
Global *ctSSLayer_InitInt
Global *ctSSLayer_LoadSongInt
Global *ctSSLayer_LoadSongPlayInt
Global *ctSSLayer_LoadSongAbortInt
Global *ctSSLayer_LoadSongFinishedInt
Global *ctSSLayer_PreInitInt
Global *ctSSLayer_GetInfoStringInt
Global *ctSSLayer_GetPositionInt
Global *ctSSLayer_SeekSongInt
Global *ctSSLayer_SetPauseInt
Global *ctSSLayer_SetVolumeInt
Global *ctSSLayer_SongLengthInt
Global *ctSSLayer_GetDeviceNameInt
Global *ctSSLayer_GetDeviceFromSSLIDInt
Global *ctSSLayer_GetDeviceSSLIDInt
Global *ctSSLayer_GetSpectrumInt
Global *ctSSLayer_MusicGetPatternInt
Global *ctSSLayer_MusicGetPatternsInt
Global *ctSSLayer_MusicHasFinishedInt
Global *ctSSLayer_MusicTimeInt
Global *ctSSLayer_ReadSongInfoInt
Global *ctSSLayer_RefreshDeviceListInt
Global *ctSSLayer_SetEndCallbackInt
Global *ctSSLayer_SetSpectrumInt
Global *ctSSLayer_UpdateCDDAInt
Global *ctSSLayer_UpdateLoopingInt
Global *ctSSLayer_UpdatePanningInt
Global *ctSSLayer_UnloadSongInt
Global *ctSSLayer_SetDebuggerInt
Global *ctSSLayer_SoundFontGetCurrentInt
Global *ctSSLayer_SoundFontGetSizeInt
Global *ctSSLayer_SoundFontGetCaptionInt
Global *ctSSLayer_SoundFontGetFilenameInt
Global *ctSSLayer_SoundFontSetInt
Global *ctSSLayer_SoundFontRefreshListInt
Global *ctSSLayer_SoundFontNumAffectedFilesInt
Global *ctSSLayer_SoundFontAffectsSpecificSongInt

Structure ctSSLayerSongInfoBase
  FormatOK.l ; Boolean
  Format_Frequency.l
  Format_BitRate.l
  Format_Channels.l
  Format_VBR.l ; Boolean
  Format_QualityMulti.f
  TagOK.l ;Boolean
  Tag_Year.l
  Tag_TrackID.l
  EndStructure
Structure ctSSLayerSongInfoReal Extends ctSSLayerSongInfoBase
  Tag_Artist.i
  Tag_Title.i
  Tag_Album.i
  IR_Name.i
  IR_URL.i
  EndStructure
Structure ctSSLayerSongInfoNeat Extends ctSSLayerSongInfoBase
  Tag_Artist.s
  Tag_Title.s
  Tag_Album.s
  IR_Name.s
  IR_URL.s
  EndStructure

Procedure.i ctSSLayer_LoadVB(DLLFilename.s)
  Define.i xResult
  Define.i xLong1
  ;1=ok/versionid, -1=no dll, 0=incompatible

  xResult = -1
  *ctSSLayer_hDLL = LoadLibrary_(DLLFilename)
  If *ctSSLayer_hDLL
    xResult = 0
    xLong1 = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_Version")
    If xLong1
      If CallFunctionFast(xLong1, #LayerVersionID)
        *ctSSLayer_CanUseItemInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_CanUseItem")
        *ctSSLayer_GetPositionInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_GetPosition")
        *ctSSLayer_GetSpectrumInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_GetSpectrum")
        *ctSSLayer_LoadSongAbortInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_LoadSongAbort")
        *ctSSLayer_LoadSongFinishedInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_LoadSongFinished")
        *ctSSLayer_LoadSongPlayInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_LoadSongPlay")
        *ctSSLayer_MusicGetPatternInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_MusicGetPattern")
        *ctSSLayer_MusicGetPatternsInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_MusicGetPatterns")
        *ctSSLayer_MusicHasFinishedInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_MusicHasFinished")
        *ctSSLayer_MusicTimeInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_MusicTime")
        *ctSSLayer_SeekSongInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SeekSong")
        *ctSSLayer_SetPauseInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SetPause")
        *ctSSLayer_SetVolumeInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SetVolume")
        *ctSSLayer_SongLengthInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SongLength")
        *ctSSLayer_UnloadSongInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_UnloadSong")
        *ctSSLayer_DllReleaseInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_DllRelease")
        *ctSSLayer_CloseInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_Close")
        *ctSSLayer_InitInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_Init")
        *ctSSLayer_PreInitInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_PreInit")
        *ctSSLayer_RefreshDeviceListInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_RefreshDeviceList")
        *ctSSLayer_SetEndCallbackInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SetEndCallback")
        *ctSSLayer_SetSpectrumInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SetSpectrum")
        *ctSSLayer_UpdateCDDAInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_UpdateCDDA")
        *ctSSLayer_UpdateLoopingInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_UpdateLooping")
        *ctSSLayer_UpdatePanningInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_UpdatePanning")
        *ctSSLayer_SoundFontGetCurrentInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SoundFontGetCurrent")
        *ctSSLayer_SoundFontGetSizeInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SoundFontGetSize")
        *ctSSLayer_SoundFontSetInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SoundFontSet")
        *ctSSLayer_SoundFontRefreshListInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SoundFontRefreshList")
        *ctSSLayer_SoundFontNumAffectedFilesInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SoundFontNumAffectedFiles")
        *ctSSLayer_SoundFontAffectsSpecificSongInt = GetProcAddress(*ctSSLayer_hDLL, "ctSSLayer_SoundFontAffectsSpecificSong")
        *ctSSLayer_GetDeviceNameInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_GetDeviceName")
        *ctSSLayer_GetDeviceSSLIDInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_GetDeviceSSLID")
        *ctSSLayer_GetInfoStringInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_GetInfoString")
        *ctSSLayer_LoadSongInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_LoadSong")
        *ctSSLayer_ReadSongInfoInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_ReadSongInfo")
        *ctSSLayer_GetDeviceFromSSLIDInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_GetDeviceFromSSLID")
        *ctSSLayer_SetDebuggerInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_SetDebugger")
        *ctSSLayer_SoundFontGetCaptionInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_SoundFontGetCaption")
        *ctSSLayer_SoundFontGetFilenameInt = GetProcAddressAW(*ctSSLayer_hDLL, "ctSSLayer_SoundFontGetFilename")
        xResult = 1
        EndIf
      EndIf
    If Not xResult
      FreeLibrary_(*ctSSLayer_hDLL)
      *ctSSLayer_hDLL = 0
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure ctSSLayer_UnLoadVB()
  If *ctSSLayer_hDLL
    CallFunctionFast(*ctSSLayer_DllReleaseInt)
    FreeLibrary_(*ctSSLayer_hDLL)
    *ctSSLayer_hDLL = 0
    EndIf
  EndProcedure

Macro ctSSLayer_CanUseItem(Index)
  CallFunctionFast(*ctSSLayer_CanUseItemInt, Index)
  EndMacro
Macro ctSSLayer_Close(Fast)
  CallFunctionFast(*ctSSLayer_CloseInt, Fast)
  EndMacro
Macro ctSSLayer_GetPosition(SongPointer)
  CallFunctionFast(*ctSSLayer_GetPositionInt, SongPointer)
  EndMacro
Macro ctSSLayer_Init(OutputDeviceID, hWnd, UseCDDA, UseJitterCorrection)
  CallFunctionFast(*ctSSLayer_InitInt, OutputDeviceID, hWnd, UseCDDA, UseJitterCorrection)
  EndMacro
Macro ctSSLayer_LoadSong(Mode, Filename, Flags)
  CallFunctionFast(*ctSSLayer_LoadSongInt, Mode, Filename, Flags)
  EndMacro
Macro ctSSLayer_LoadSongAbort(SongPointer)
  CallFunctionFast(*ctSSLayer_LoadSongAbortInt, SongPointer)
  EndMacro
Macro ctSSLayer_LoadSongFinished(SongPointer)
  CallFunctionFast(*ctSSLayer_LoadSongFinishedInt, SongPointer)
  EndMacro
Macro ctSSLayer_LoadSongPlay(SongPointer, Volume, LoopSong, Panning, Paused)
  CallFunctionFast(*ctSSLayer_LoadSongPlayInt, SongPointer, Volume, LoopSong, Panning, Paused)
  EndMacro
Macro ctSSLayer_PreInit(hWnd)
  CallFunctionFast(*ctSSLayer_PreInitInt, hWnd)
  EndMacro
Macro ctSSLayer_SeekSong(SongPointer, SeekPosition)
  CallFunctionFast(*ctSSLayer_SeekSongInt, SongPointer, SeekPosition)
  EndMacro
Macro ctSSLayer_SetPause(SongPointer, Pause)
  CallFunctionFast(*ctSSLayer_SetPauseInt, SongPointer, Pause)
  EndMacro
Macro ctSSLayer_SetVolume(SongPointer, Volume)
  CallFunctionFast(*ctSSLayer_SetVolumeInt, SongPointer, Volume)
  EndMacro
Macro ctSSLayer_SongLength(SongPointer)
  CallFunctionFast(*ctSSLayer_SongLengthInt, SongPointer)
  EndMacro
Macro ctSSLayer_UnloadSong(SongPointer)
  CallFunctionFast(*ctSSLayer_UnloadSongInt, SongPointer)
  EndMacro
Macro ctSSLayer_RefreshDeviceList(hWnd)
  CallFunctionFast(*ctSSLayer_RefreshDeviceListInt, hWnd)
  EndMacro
Macro ctSSLayer_GetSpectrum(xSingleA1Array, ArraySize, SongPointer, StereoMode)
  CallFunctionFast(*ctSSLayer_GetSpectrumInt, xSingleA1Array, ArraySize, SongPointer, StereoMode)
  EndMacro
Macro ctSSLayer_SetEndCallback(hWnd, Message, wParam)
  CallFunctionFast(*ctSSLayer_SetEndCallbackInt, hWnd, Message, wParam)
  EndMacro
Macro ctSSLayer_SetSpectrum(State)
  CallFunctionFast(*ctSSLayer_SetSpectrumInt, State)
  EndMacro
Macro ctSSLayer_UpdateCDDA(UseCDDA, UseJitterCorrection)
  CallFunctionFast(*ctSSLayer_UpdateCDDAInt, UseCDDA, UseJitterCorrection)
  EndMacro
Macro ctSSLayer_UpdateLooping(SongPointer, LoopSong)
  CallFunctionFast(*ctSSLayer_UpdateLoopingInt, SongPointer, LoopSong)
  EndMacro
Macro ctSSLayer_UpdatePanning(SongPointer, Panning)
  CallFunctionFast(*ctSSLayer_UpdatePanningInt, SongPointer, Panning)
  EndMacro
Macro ctSSLayer_MusicGetPattern(SongPointer)
  CallFunctionFast(*ctSSLayer_MusicGetPatternInt, SongPointer)
  EndMacro
Macro ctSSLayer_MusicGetPatterns(SongPointer)
  CallFunctionFast(*ctSSLayer_MusicGetPatternsInt, SongPointer)
  EndMacro
Macro ctSSLayer_MusicHasFinished(SongPointer)
  CallFunctionFast(*ctSSLayer_MusicHasFinishedInt, SongPointer)
  EndMacro
Macro ctSSLayer_MusicTime(SongPointer)
  CallFunctionFast(*ctSSLayer_MusicTimeInt, SongPointer)
  EndMacro
Macro ctSSLayer_GetDeviceFromSSLID(ptrDeviceSSLID)
  CallFunctionFast(*ctSSLayer_GetDeviceFromSSLIDInt, ptrDeviceSSLID)
  EndMacro
Procedure.s ctSSLayer_GetInfoString(Index.i)
  Define.s xResult
  Index = CallFunctionFast(*ctSSLayer_GetInfoStringInt, Index)
  If Index
    xResult = PeekS(Index)
    EndIf
  ProcedureReturn xResult
  EndProcedure
Procedure.s ctSSLayer_GetDeviceName(DeviceID.i, *Flags)
  Define.s xResult
  DeviceID = CallFunctionFast(*ctSSLayer_GetDeviceNameInt, DeviceID, *Flags)
  If DeviceID
    xResult = PeekS(DeviceID)
    EndIf
  ProcedureReturn xResult
  EndProcedure
Procedure.s ctSSLayer_GetDeviceSSLID(DeviceID.i)
  Define.s xResult
  DeviceID = CallFunctionFast(*ctSSLayer_GetDeviceSSLIDInt, DeviceID)
  If DeviceID
    xResult = PeekS(DeviceID)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i ctSSLayer_ReadSongInfo(SongPointer.i, *xSongInfo.ctSSLayerSongInfoNeat)
  Define.i xResult
  Define.ctSSLayerSongInfoReal xType1

  xResult = CallFunctionFast(*ctSSLayer_ReadSongInfoInt, SongPointer, @xType1)
  If xResult
    MemCopyRTL(*xSongInfo, @xType1, SizeOf(ctSSLayerSongInfoBase))
    If xType1\Tag_Artist
      *xSongInfo\Tag_Artist = PeekS(xType1\Tag_Artist)
      Else
      *xSongInfo\Tag_Artist = ""
      EndIf
    If xType1\Tag_Title
      *xSongInfo\Tag_Title =  PeekS(xType1\Tag_Title)
      Else
      *xSongInfo\Tag_Title = ""
      EndIf
    If xType1\Tag_Album
      *xSongInfo\Tag_Album =  PeekS(xType1\Tag_Album)
      Else
      *xSongInfo\Tag_Album = ""
      EndIf
    If xType1\IR_Name
      *xSongInfo\IR_Name =    PeekS(xType1\IR_Name)
      Else
      *xSongInfo\IR_Name = ""
      EndIf
    If xType1\IR_URL
      *xSongInfo\IR_URL =     PeekS(xType1\IR_URL)
      Else
      *xSongInfo\IR_URL = ""
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure ctSSLayer_SetDebugger(ptrDebuggerProc)
  If *ctSSLayer_SetDebuggerInt
    CallFunctionFast(*ctSSLayer_SetDebuggerInt, ptrDebuggerProc)
    EndIf
  EndProcedure

Procedure.i ctSSLayer_SoundFontGetCurrent()
  ProcedureReturn CallFunctionFast(*ctSSLayer_SoundFontGetCurrentInt)
  EndProcedure

Procedure.s ctSSLayer_SoundFontGetCaption(SoundFontID.i)
  Define.s xResult
  SoundFontID = CallFunctionFast(*ctSSLayer_SoundFontGetCaptionInt, SoundFontID)
  If SoundFontID
    xResult = PeekS(SoundFontID)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.s ctSSLayer_SoundFontGetFilename(SoundFontID.i)
  Define.s xResult
  SoundFontID = CallFunctionFast(*ctSSLayer_SoundFontGetFilenameInt, SoundFontID)
  If SoundFontID
    xResult = PeekS(SoundFontID)
    EndIf
  ProcedureReturn xResult
  EndProcedure

Procedure.i ctSSLayer_SoundFontSet(SoundFontID.i)
  ProcedureReturn CallFunctionFast(*ctSSLayer_SoundFontSetInt, SoundFontID)
  EndProcedure

Macro ctSSLayer_SoundFontRefreshList(Flags)
  CallFunctionFast(*ctSSLayer_SoundFontRefreshListInt, Flags)
  EndMacro

Macro ctSSLayer_SoundFontNumAffectedFiles()
  CallFunctionFast(*ctSSLayer_SoundFontNumAffectedFilesInt)
  EndMacro

Macro ctSSLayer_SoundFontAffectsSpecificSong(SongPointer)
  CallFunctionFast(*ctSSLayer_SoundFontAffectsSpecificSongInt, SongPointer)
  EndMacro

Macro ctSSLayer_SoundFontGetSize(SoundFontID, QuadPointer)
  CallFunctionFast(*ctSSLayer_SoundFontGetSizeInt, SoundFontID, QuadPointer)
  EndMacro


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 333
; FirstLine = 326
; Folding = -------
; EnableUnicode
; EnableXP
; CompileSourceDirectory